unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, math, ExtCtrls, IniFiles, Registry;

type
  TForm1 = class(TForm)
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    procedure FormShow(Sender: TObject);
  private
    function WNTProcedure(folder: string; bg, fg: TColor): boolean;
    function W95Procedure(folder: string; bg, fg: TColor): boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function bits(b: byte): string;
var
  i, p: integer;
begin
  result := '';

  for i := 7 downto 0 do
  begin
    p := round(power(2, i));
    if (b >= p) then
    begin
      result := result + '1';
            b := b - p;
    end
    else
      result := result + '0';
  end;
end;

procedure exp(a, fn: string; bg, fg: TColor);
var
  i,j: integer;
  k,s: string;
  sl: tstringlist;
begin
  s := StringReplace(a, ' ', #13#10, [rfReplaceAll]);

  sl := TStringList.Create;
  try
    sl.Text := s;
    for i := 0 to sl.Count - 1 do
    begin
      k := bits(strtoint(sl.strings[i]));
      for j := 1 to length(k) do
      begin
        if (k[j] = '1') then
          form1.image1.Canvas.Pixels[j-1, i] := fg
        else
          form1.image1.Canvas.Pixels[j-1, i] := bg;
      end;
    end;
  finally
    sl.free;
  end;

  form1.Image1.Picture.SaveToFile(fn);
end;

function TForm1.W95Procedure(folder: string; bg, fg: TColor): boolean;
var
  v: string;
  ini: TIniFile;
  i: integer;
  ini_fn: string;
  windir: string;
  x: tstringlist;
begin
  result := false;

  windir := GetEnvironmentVariable('windir');
  if windir = '' then windir := 'C:\Windows\';
  windir := IncludeTrailingPathDelimiter(windir);

  ini_fn := windir+'Control.ini';
  if not fileExists(ini_fn) then
  begin
    (* showmessage('Error: Control.ini not found. Where is it?');

    if OpenDialog1.Execute then
    begin
      ini_fn := OpenDialog1.Filename;
    end
    else
    begin
      Exit;
    end; *)
    Exit;
  end;

  ini := TIniFile.Create(ini_fn);
  try
    x := tstringlist.Create;
    try
      ini.ReadSection('Patterns', x);
      for i := 0 to x.count - 1 do
      begin
        result := true;
        v := ini.ReadString('Patterns', x.strings[i], '');
        if ansipos(' ', v) <> 0 then
          exp(v, folder+'\'+x.strings[i]+'.bmp', bg, fg);
      end;
    finally
      x.Free;
    end;
  finally
    ini.Free;
  end;
end;

function TForm1.WNTProcedure(folder: string; bg, fg: TColor): boolean;
var
  v: string;
  i: integer;
  x: tstringlist;
  reg: TRegistry;
begin
  result := false;
  reg := TRegistry.Create;

  try
    reg.RootKey := HKEY_CURRENT_USER;
    if reg.OpenKey('Control Panel\Patterns\', false) then
    begin
      x := tstringlist.Create;
      try
        reg.GetValueNames(x);
        for i := 0 to x.count - 1 do
        begin
          result := true;
          v := reg.ReadString(x.strings[i]);
          if ansipos(' ', v) <> 0 then
            exp(v, folder+'\'+x.strings[i]+'.bmp', bg, fg);
        end;
      finally
        x.Free;
      end;
      reg.closeKey;
    end;
  finally
    reg.Free;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  folder: string;
  bg, fg: TColor;
begin
  ShowMessage('Hintergrundfarbe / Background color ?');
  ColorDialog1.Color := clWhite;
  if ColorDialog1.Execute then
  begin
    bg := ColorDialog1.color;
  end
  else
  begin
    Close;
    exit;
  end;
  ShowMessage('Vordergrundfarbe / Line color?');
  ColorDialog2.Color := clBlack;
  if ColorDialog2.Execute then
  begin
    fg := ColorDialog2.color;
  end
  else
  begin
    Close;
    exit;
  end;
  folder := ExtractFilePath(Application.ExeName)+'Patterns';
  mkdir(folder);
  W95Procedure(folder, bg, fg);
  WNTProcedure(folder, bg, fg);
  close;
end;

end.
